1. 程式人生 > >HDU 1087 Super Jumping! Jumping! Jumping!

HDU 1087 Super Jumping! Jumping! Jumping!

blog col som oss score ++ all you finall

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now. 技術分享 The game can be played by two or more than two players. It consists of a chessboard(棋盤)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. Your task is to output the maximum value according to the given chessmen list. Input Input contains multiple test cases. Each test case is described in a line as follow: N value_1 value_2 …value_N It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. A test case starting with 0 terminates the input and this test case is not to be processed. Output For each case, print the maximum according to rules, and one line one case. Sample Input 3 1 3 2 4 1 2 3 4 4 3 3 2 1 0 Sample Output 4 10 3 題意分析: 求最大遞增序列之和 狀態轉移方程為: ans = max(ans,dp[j]); ans為以j結尾的最大遞增子序列的和;其中用dp[]儲存以i為結尾的最大遞增序列的和, dp[i] = ans + a[i]; 註意由於需要考慮是所有的和,所以循環應為 for(i=1;i<=m;i++) for(j=0;j<i;j++) 最後只要比較以各個位置為結點的dp[i]的值便可。 綜上,實現代碼為:
#include<bits/stdc++.h>
using
namespace std; int main() { int i,j,m,a[1005],dp[1005]; while(cin>>m&&m) { for(i=1;i<=m;i++) cin>>a[i]; memset(dp,0,sizeof(dp)); for(i=1;i<=m;i++) { int ans = -10000000; for(j=0;j<i;j++) //求出以各個位置為節點的最大值 {
if(a[i]>a[j]) ans = max(ans,dp[j]); } dp[i] = ans + a[i]; } int ans = -10000000; for(i=1;i<=m;i++) //取各個節點的最大值,即為最大遞增序列之和 { if(ans<dp[i]) ans = dp[i]; } cout<<ans<<endl; }
return 0; }

HDU 1087 Super Jumping! Jumping! Jumping!